import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.IOException;
import java.net.InetAddress;
import com.illposed.osc.*;

public class TestServerOsc extends PositionMap{
	Object[] args=new Object[1];
	float[] i={(float)0.004,(float)0.02};
	OSCMessage msg=new OSCMessage("/sayhello",args);
	OSCPortOut sender;

	public TestServerOsc(){
		super("TestServer",(float)1.0,(float)2.0);
		args[0]="0.3 3.2 4.2";
		
	}
	
	
	
	public static void main(String[]a){
		TestServerOsc tso=new TestServerOsc();
		tso.forHoppingSweeperWithGUI();
	}
	
	private void forHoppingSweeperWithGUI(){
		setVisible(true);
		this.addKeyListener(new KeyCommands());
	}

	class KeyCommands implements KeyListener{

		@Override
		public void keyPressed(KeyEvent e) {
			check(e);
			try{
					sender = new OSCPortOut(InetAddress.getByName("127.0.0.1"), 9999);
					args[0]=Float.toString(getXPosition())+" "+Float.toString(getYPosition())+" "+"0.0";		
					System.out.println(args[0]);
					msg=new OSCMessage("/sayhello",args);
					msg.addArgument(args);
					sender.send(msg);
			}catch (IOException e1) {
				e1.printStackTrace();
			}
			
		}

		@Override
		public void keyReleased(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void keyTyped(KeyEvent e) {
			// TODO Auto-generated method stub
			
		}
		void check(KeyEvent e){
			int keyCode=e.getKeyCode();
			switch(keyCode){
			case KeyEvent.VK_UP:
				y=(float)(y+0.05);
				repaint();
				break;
			case KeyEvent.VK_DOWN:
				y=(float)(y-0.05);
				repaint();
				break;
			case KeyEvent.VK_RIGHT:
				x=(float)(x+0.05);
				repaint();
				break;
			case KeyEvent.VK_LEFT:
				x=(float)(x-0.05);
				repaint();
			}
		}
	}
	
	
	private void forHoppingSweeper(){
		OSCMessage msg=new OSCMessage("/sayhello",args);
		OSCPortOut sender;
		try {

			sender = new OSCPortOut(InetAddress.getByName("127.0.0.1"), 9999);
			//sender = new OSCPortOut();
			for(int seq=0;seq<4;){
				switch(seq){
				case 0:
					if(i[0]>1.65 && i[1]<-0.2){
						Thread.sleep(2000);
						seq++;
					}
					else {
						if(i[1]>-0.2)i[1]-=(float)0.052;
						else if(i[0]<1.65)i[0]+=(float)0.093;
					}
					break;
				case 1:
					if(i[1]>0.2){
						seq++;
						Thread.sleep(2000);
					}
					else i[1]+=0.052;
					break;
				case 2:
					if(i[0]<0.05){
						Thread.sleep(2000);
						seq=0;
						i[0]=i[1]=0;
					}
					else i[0]-=0.095;
					break;					
				}
				args[0]=Float.toString(i[1])+" "+Float.toString(i[0])+" "+"0.0";		
				System.out.println(args[0]);
				msg=new OSCMessage("/sayhello",args);
				Thread.sleep(300);
				msg.addArgument(args);
				sender.send(msg);
			}
		} catch (IOException e1) {
			e1.printStackTrace();
		} catch (InterruptedException e) {
			// TODO ꂽ catch ubN
			e.printStackTrace();
		}
	}
}